OGRE: Ogre::PVRTCCodec Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Public Types | Public Member Functions | Static Public Member Functions | List of all members
Ogre::PVRTCCodec Class Reference
Core » Image

Codec specialized in loading PVRTC (PowerVR) images. More...

`#include <OgrePVRTCCodec.h>`

Inheritance diagram for Ogre::PVRTCCodec:
[legend]

## Public Types
typedef SharedPtr< CodecData > | CodecDataPtr
typedef ConstMapIterator< CodecList > | CodecIterator
typedef std::pair< MemoryDataStreamPtr, CodecDataPtr > | DecodeResult
| Result of a decoding; both a decoded data stream and CodecData metadata. More...

## Public Member Functions
| PVRTCCodec ()
virtual | ~PVRTCCodec ()
DecodeResult | decode (DataStreamPtr &input) const
| Codes the data from the input chunk into the output chunk. More...
DataStreamPtr | encode (MemoryDataStreamPtr &input, CodecDataPtr &pData) const
| Codes the data in the input stream and saves the result in the output stream. More...
void | encodeToFile (MemoryDataStreamPtr &input, const String &outFileName, CodecDataPtr &pData) const
| Codes the data in the input chunk and saves the result in the output filename provided. More...
virtual String | getDataType () const
| Returns the type of the data that supported by this codec as a String. More...
virtual String | getType () const
| Returns the type of the codec as a String. More...
virtual bool | magicNumberMatch (const char *magicNumberPtr, size_t maxbytes) const
| Returns whether a magic number header matches this codec. More...
String | magicNumberToFileExt (const char *magicNumberPtr, size_t maxbytes) const
| Maps a magic number header to a file extension, if this codec recognises it. More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...

## Static Public Member Functions
static Codec * | getCodec (char *magicNumberPtr, size_t maxbytes)
| Gets the codec that can handle the given 'magic' identifier. More...
static Codec * | getCodec (const String &extension)
| Gets the codec registered for the passed in file extension. More...
static CodecIterator | getCodecIterator (void)
| Gets the iterator for the registered codecs. More...
static StringVector | getExtensions (void)
| Gets the file extension list for the registered codecs. More...
static bool | isCodecRegistered (const String &codecType)
| Return whether a codec is registered already. More...
static void | registerCodec (Codec *pCodec)
| Registers a new codec in the database. More...
static void | shutdown (void)
| Static method to shutdown and unregister the PVRTC codec. More...
static void | startup (void)
| Static method to startup and register the PVRTC codec. More...
static void | unregisterCodec (Codec *pCodec)
| Unregisters a codec from the database. More...

## Detailed Description

Codec specialized in loading PVRTC (PowerVR) images.

Remarks
  We implement our own codec here since we need to be able to keep PVRTC data compressed if the card supports it.

## Member Typedef Documentation

## ◆ CodecDataPtr

typedef SharedPtr<CodecData> Ogre::Codec::CodecDataPtr
| inherited

## ◆ CodecIterator

typedef ConstMapIterator<CodecList> Ogre::Codec::CodecIterator
| inherited

## ◆ DecodeResult

typedef std::pair<MemoryDataStreamPtr, CodecDataPtr> Ogre::Codec::DecodeResult
| inherited

Result of a decoding; both a decoded data stream and CodecData metadata.

## Constructor & Destructor Documentation

## ◆ PVRTCCodec()

Ogre::PVRTCCodec::PVRTCCodec | ( |  | ) |

## ◆ ~PVRTCCodec()

virtual Ogre::PVRTCCodec::~PVRTCCodec | ( |  | ) |
| inlinevirtual

## Member Function Documentation

## ◆ decode()

DecodeResult Ogre::PVRTCCodec::decode | ( | DataStreamPtr & | input | ) | const
| virtual

Codes the data from the input chunk into the output chunk.

Parameters

  input | Stream containing the encoded data

Implements Ogre::Codec.

## ◆ encode()

DataStreamPtr Ogre::PVRTCCodec::encode | ( | MemoryDataStreamPtr & | input,
|  | CodecDataPtr & | pData
| ) |  | const
| virtual

Codes the data in the input stream and saves the result in the output stream.

Implements Ogre::Codec.

## ◆ encodeToFile()

void Ogre::PVRTCCodec::encodeToFile | ( | MemoryDataStreamPtr & | input,
|  | const String & | outFileName,
|  | CodecDataPtr & | pData
| ) |  | const
| virtual

Codes the data in the input chunk and saves the result in the output filename provided.

Provided for efficiency since coding to memory is progressive therefore memory required is unknown leading to reallocations.

Parameters

  input | The input data
  outFileName | The filename to write to
  pData | Extra information to be passed to the codec (codec type specific)

Implements Ogre::Codec.

## ◆ getCodec() [1/2]

static Codec* Ogre::Codec::getCodec | ( | char * | magicNumberPtr,
|  | size_t | maxbytes
| ) |  |
| staticinherited

Gets the codec that can handle the given 'magic' identifier.

Parameters

  magicNumberPtr | Pointer to a stream of bytes which should identify the file. Note that this may be more than needed - each codec may be looking for a different size magic number.
  maxbytes | The number of bytes passed

## ◆ getCodec() [2/2]

static Codec* Ogre::Codec::getCodec | ( | const String & | extension | ) |
| staticinherited

Gets the codec registered for the passed in file extension.

## ◆ getCodecIterator()

static CodecIterator Ogre::Codec::getCodecIterator | ( | void |  | ) |
| inlinestaticinherited

Gets the iterator for the registered codecs.

## ◆ getDataType()

virtual String Ogre::ImageCodec2::getDataType | ( |  | ) | const
| inlinevirtualinherited

Returns the type of the data that supported by this codec as a String.

Implements Ogre::Codec.

## ◆ getExtensions()

static StringVector Ogre::Codec::getExtensions | ( | void |  | ) |
| staticinherited

Gets the file extension list for the registered codecs.

## ◆ getType()

virtual String Ogre::PVRTCCodec::getType | ( |  | ) | const
| virtual

Returns the type of the codec as a String.

Implements Ogre::Codec.

## ◆ isCodecRegistered()

static bool Ogre::Codec::isCodecRegistered | ( | const String & | codecType | ) |
| inlinestaticinherited

Return whether a codec is registered already.

## ◆ magicNumberMatch()

virtual bool Ogre::Codec::magicNumberMatch | ( | const char * | magicNumberPtr,
|  | size_t | maxbytes
| ) |  | const
| inlinevirtualinherited

Returns whether a magic number header matches this codec.

Parameters

  magicNumberPtr | Pointer to a stream of bytes which should identify the file. Note that this may be more than needed - each codec may be looking for a different size magic number.
  maxbytes | The number of bytes passed

## ◆ magicNumberToFileExt()

String Ogre::PVRTCCodec::magicNumberToFileExt | ( | const char * | magicNumberPtr,
|  | size_t | maxbytes
| ) |  | const
| virtual

Maps a magic number header to a file extension, if this codec recognises it.

Parameters

  magicNumberPtr | Pointer to a stream of bytes which should identify the file. Note that this may be more than needed - each codec may be looking for a different size magic number.
  maxbytes | The number of bytes passed

Returns
  A blank string if the magic number was unknown, or a file extension.

Implements Ogre::Codec.

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ registerCodec()

static void Ogre::Codec::registerCodec | ( | Codec * | pCodec | ) |
| inlinestaticinherited

Registers a new codec in the database.

References Ogre::Exception::ERR_DUPLICATE_ITEM, Ogre::Codec::getType(), and OGRE_EXCEPT.

## ◆ shutdown()

static void Ogre::PVRTCCodec::shutdown | ( | void |  | ) |
| static

Static method to shutdown and unregister the PVRTC codec.

## ◆ startup()

static void Ogre::PVRTCCodec::startup | ( | void |  | ) |
| static

Static method to startup and register the PVRTC codec.

## ◆ unregisterCodec()

static void Ogre::Codec::unregisterCodec | ( | Codec * | pCodec | ) |
| inlinestaticinherited

Unregisters a codec from the database.

References Ogre::Codec::getType().

The documentation for this class was generated from the following file:

- OgrePVRTCCodec.h